function async_psych_analysis(version, obv_thresh, max_async, min_combofit_atoms)
hard_subjects = [29:32, 39:55];
hardnomem_subjects = [56:73];
mega_subjects = [74:89];
subj_dirs = '/KLAB_BACKUP/people/jedsinger/async_psych_subjects';

%Run with: for ot = [.8 .85 .9 1]; for ma = [220 320 0]; for mca = [2 3]; async_psych_analysis('easy', ot, ma, mca); close all; async_psych_analysis('hard', ot, ma, mca); close all; async_psych_analysis('hardnomem', ot, ma, mca); close all; async_psych_analysis('mega', ot, ma, mca); close all; end; end; end

warning('The vertical dotted lines showing tau are for the population fits, not the means of the individual fits (as used in the manuscript figures');


warning off all

use_eyetracking = 1;
use_frag_obviousness_filter = 1;
if use_frag_obviousness_filter ~= 1
	obv_thresh = Inf;
end

bob = clock; bob = num2str(bob(1:5), '%d_%d_%d_%d_%d');
bob = [bob '_' version '_' num2str(obv_thresh, '%1.2f') '_' num2str(max_async, '%d') '_' num2str(min_combofit_atoms, '%d') '.txt'];
diary(fullfile(subj_dirs, bob));
eval(['subj_list = ' version '_subjects;']);

silhouettes_only = 0;

if strcmp(version, 'mega')
	mna = 3;
    min_combofit_atoms = 3;
else
	mna = 2;
end

cartoon_images = {'Animals_125.png', 'People_67.png', 'Plants_281.png', 'Animals_126.png', 'People_69.png', 'Plants_282.png', 'Animals_155.png', 'People_72.png', 'Plants_54.png', 'Animals_158.png', 'People_73.png', 'Plants_56.png', 'Animals_161.png', 'People_74.png', 'Plants_57.png', 'Animals_162.png', 'People_77.png', 'Plants_93.png', 'Animals_169.png', 'People_78.png', 'Vehicles_108.png', 'Animals_176.png', 'People_79.png', 'Vehicles_118.png', 'Animals_178.png', 'People_81.png', 'Vehicles_131.png', 'Animals_217.png', 'People_82.png', 'Vehicles_140.png', 'Animals_228.png', 'People_83.png', 'Vehicles_154.png', 'Animals_248.png', 'People_84.png', 'Vehicles_166.png', 'Animals_251.png', 'People_85.png', 'Vehicles_167.png', 'Animals_253.png', 'Plants_127.png', 'Vehicles_169.png', 'Animals_256.png', 'Plants_132.png', 'Vehicles_170.png', 'Animals_257.png', 'Plants_158.png', 'Vehicles_175.png', 'Animals_264.png', 'Plants_182.png', 'Vehicles_182.png', 'Animals_27.png', 'Plants_195.png', 'Vehicles_187.png', 'Animals_276.png', 'Plants_2.png', 'Vehicles_190.png', 'Animals_287.png', 'Plants_230.png', 'Vehicles_191.png', 'People_105.png', 'Plants_237.png', 'Vehicles_196.png', 'People_153.png', 'Plants_238.png', 'Vehicles_279.png', 'People_210.png', 'Plants_240.png', 'Vehicles_283.png', 'People_217.png', 'Plants_242.png', 'Vehicles_293.png', 'People_237.png', 'Plants_268.png', 'Vehicles_51.png', 'People_249.png', 'Plants_276.png', 'Vehicles_57.png', 'People_255.png', 'Plants_279.png'};
silhouette_images = {'Animals_1.png', 'People_100.png', 'Vehicles_12.png', 'Animals_10.png', 'People_106.png', 'Vehicles_13.png', 'Animals_103.png', 'People_108.png', 'Vehicles_15.png', 'Animals_106.png', 'People_112.png', 'Vehicles_164.png', 'Animals_109.png', 'People_114.png', 'Vehicles_165.png', 'Animals_12.png', 'People_118.png', 'Vehicles_17.png', 'Animals_13.png', 'People_128.png', 'Vehicles_178.png', 'Animals_14.png', 'People_134.png', 'Vehicles_179.png', 'Animals_15.png', 'People_135.png', 'Vehicles_183.png', 'Animals_154.png', 'People_138.png', 'Vehicles_185.png', 'Animals_17.png', 'People_147.png', 'Vehicles_186.png', 'Animals_177.png', 'People_148.png', 'Vehicles_188.png', 'Animals_2.png', 'People_15.png', 'Vehicles_193.png', 'Animals_200.png', 'People_151.png', 'Vehicles_20.png', 'Animals_201.png', 'People_156.png', 'Vehicles_205.png', 'Animals_203.png', 'People_157.png', 'Vehicles_206.png', 'Animals_209.png', 'People_166.png', 'Vehicles_207.png', 'Animals_21.png', 'People_167.png', 'Vehicles_208.png', 'Animals_210.png', 'People_168.png', 'Vehicles_210.png', 'Animals_22.png', 'People_172.png', 'Vehicles_211.png', 'Animals_222.png', 'People_177.png', 'Vehicles_212.png', 'Animals_227.png', 'People_178.png', 'Vehicles_213.png', 'Animals_229.png', 'People_181.png', 'Vehicles_216.png', 'Animals_232.png', 'People_183.png', 'Vehicles_217.png', 'Animals_233.png', 'People_184.png', 'Vehicles_219.png', 'Animals_234.png', 'People_187.png', 'Vehicles_220.png', 'Animals_236.png', 'People_19.png', 'Vehicles_221.png', 'Animals_238.png', 'People_196.png', 'Vehicles_224.png', 'Animals_249.png', 'People_199.png', 'Vehicles_229.png', 'Animals_25.png', 'People_203.png', 'Vehicles_23.png', 'Animals_26.png', 'People_209.png', 'Vehicles_230.png', 'Animals_263.png', 'People_212.png', 'Vehicles_232.png', 'Animals_265.png', 'People_216.png', 'Vehicles_234.png', 'Animals_266.png', 'People_221.png', 'Vehicles_243.png', 'Animals_28.png', 'People_222.png', 'Vehicles_244.png', 'Animals_292.png', 'People_228.png', 'Vehicles_245.png', 'Animals_293.png', 'People_23.png', 'Vehicles_25.png', 'Animals_294.png', 'People_240.png', 'Vehicles_254.png', 'Animals_295.png', 'People_260.png', 'Vehicles_26.png', 'Animals_297.png', 'People_269.png', 'Vehicles_265.png', 'Animals_298.png', 'People_274.png', 'Vehicles_27.png', 'Animals_3.png', 'People_294.png', 'Vehicles_277.png', 'Animals_32.png', 'People_34.png', 'Vehicles_28.png', 'Animals_35.png', 'People_36.png', 'Vehicles_281.png', 'Animals_36.png', 'People_40.png', 'Vehicles_286.png', 'Animals_37.png', 'People_43.png', 'Vehicles_288.png', 'Animals_4.png', 'People_44.png', 'Vehicles_29.png', 'Animals_46.png', 'People_47.png', 'Vehicles_290.png', 'Animals_57.png', 'People_48.png', 'Vehicles_292.png', 'Animals_61.png', 'People_49.png', 'Vehicles_297.png', 'Animals_62.png', 'People_50.png', 'Vehicles_298.png', 'Animals_67.png', 'People_52.png', 'Vehicles_300.png', 'Animals_72.png', 'People_55.png', 'Vehicles_31.png', 'Animals_76.png', 'People_58.png', 'Vehicles_46.png', 'Animals_81.png', 'People_59.png', 'Vehicles_5.png', 'Animals_82.png', 'People_63.png', 'Vehicles_55.png', 'Animals_86.png', 'People_65.png', 'Vehicles_60.png', 'Animals_87.png', 'People_93.png', 'Vehicles_7.png', 'Animals_9.png', 'People_96.png', 'Vehicles_81.png', 'Animals_91.png', 'People_97.png', 'Vehicles_9.png'};
sketch_images = {'Animals_111.png', 'People_143.png', 'Plants_273.png', 'Animals_121.png', 'People_149.png', 'Plants_274.png', 'Animals_135.png', 'People_159.png', 'Plants_284.png', 'Animals_191.png', 'People_165.png', 'Plants_31.png', 'Animals_192.png', 'People_169.png', 'Plants_63.png', 'Animals_205.png', 'People_198.png', 'Plants_66.png', 'Animals_214.png', 'People_223.png', 'Plants_95.png', 'Animals_226.png', 'People_224.png', 'Plants_97.png', 'Animals_246.png', 'People_247.png', 'Vehicles_104.png', 'Animals_270.png', 'People_54.png', 'Vehicles_129.png', 'Animals_271.png', 'People_56.png', 'Vehicles_145.png', 'Animals_272.png', 'People_57.png', 'Vehicles_148.png', 'Animals_273.png', 'People_66.png', 'Vehicles_150.png', 'Animals_278.png', 'People_68.png', 'Vehicles_157.png', 'Animals_279.png', 'People_70.png', 'Vehicles_161.png', 'Animals_280.png', 'People_90.png', 'Vehicles_194.png', 'Animals_281.png', 'People_92.png', 'Vehicles_195.png', 'Animals_282.png', 'Plants_100.png', 'Vehicles_200.png', 'Animals_289.png', 'Plants_119.png', 'Vehicles_202.png', 'Animals_299.png', 'Plants_130.png', 'Vehicles_228.png', 'Animals_300.png', 'Plants_149.png', 'Vehicles_248.png', 'Animals_40.png', 'Plants_160.png', 'Vehicles_261.png', 'Animals_47.png', 'Plants_251.png', 'Vehicles_267.png', 'Animals_54.png', 'Plants_252.png', 'Vehicles_268.png', 'Animals_98.png', 'Plants_253.png', 'Vehicles_270.png', 'Animals_99.png', 'Plants_255.png', 'Vehicles_271.png', 'People_101.png', 'Plants_258.png', 'Vehicles_273.png', 'People_104.png', 'Plants_261.png', 'Vehicles_278.png', 'People_115.png', 'Plants_263.png', 'Vehicles_39.png', 'People_124.png', 'Plants_264.png', 'Vehicles_50.png', 'People_132.png', 'Plants_265.png', 'Vehicles_66.png', 'People_139.png', 'Plants_269.png', 'Vehicles_71.png', 'People_140.png', 'Plants_270.png', 'Vehicles_79.png', 'People_141.png', 'Plants_271.png', 'Vehicles_90.png', 'People_142.png', 'Plants_272.png'};

disp(' ')
disp(' ')
disp(' ')
disp(['Results from ' version ' version:'])
disp(['Obviousness threshold = ' num2str(obv_thresh, '%1.2f')])
disp(['Maximum asynchrony (0 means all) = ' num2str(max_async, '%d')])
disp(' ')

if exist(['/KLAB_BACKUP/people/jedsinger/behavior_figures/async_psych_' version '_combined_data_' num2str([obv_thresh max_async min_combofit_atoms], '%1.2f_%1.2f_%1.2f') '.mat'], 'file')
    load(['/KLAB_BACKUP/people/jedsinger/behavior_figures/async_psych_' version '_combined_data_' num2str([obv_thresh max_async min_combofit_atoms], '%1.2f_%1.2f_%1.2f') '.mat']);
eee = 10000; %this tells how far out to use for the end of the half-height window
else
eee = 10000; %this tells how far out to use for the end of the half-height window

asynchronies = [];

correct = [];
n_img_pres = [];
category = [];
atom_correct_by_subj = [];
atom_ci_by_subj = [];
bad_eye_trials_by_subj = [];
good_trials_by_subj = [];
counts_by_n_img_pres = [];
atom_counts_by_subj = [];
excluded_subjects = zeros(size(subj_list));
catch_perf_by_subj = [];
catch_ci_by_subj = [];
used_eyetracking_by_subj = [];
has_catch_trials = [];
fraction_obvious = [];
clear perf_by_n_img_pres perf_ci_by_n_img_pres conf_int rt_median_by_subj rt_sem_by_subj fitparams_sig sses_sig fitparams_exp sses_exp fitparams_lin sses_lin fitparams_step sses_step AIC_sig AIC_step AIC_exp AIC_lin responses_by_n_img_pres categories responses subj_asyncs subj_nip corrects

for j = 1:length(subj_list)
    eyefile = fullfile(subj_dirs, ['async_p' num2str(subj_list(j), '%03d')], ['async_p' num2str(subj_list(j), '%03d') '_async_psych_eyetracking.mat']);
	if exist(eyefile, 'file') %get everything we need from the eyelink file
		load(eyefile);
		eyefile = 1;
    else
        beh_files = dir(fullfile(subj_dirs, ['async_p' num2str(subj_list(j), '%03d')], ['async_psych_async_p' num2str(subj_list(j), '%03d') '*.mat']));
        load(fullfile(subj_dirs, ['async_p' num2str(subj_list(j), '%03d')], beh_files(end).name));
		eyefile = 0;
		end_block = sum(arrayfun(@(x) ~isempty(x.stimon_getsecs), block_struct));
       if ~strcmp(version, 'mega')
       for b = 1:end_block %fixing a bug from async_psych
                if block_struct(b).asynchronies(end) > 0
                    block_struct(b).n_img_pres(end) = min(block_struct(b).n_img_pres(end), 2);
                    block_struct(b).stimon_getsecs(end, 3:4) = nan;
                    block_struct(b).stimoff_getsecs(end, 3:4) = nan;
                    block_struct(b).frags_used{end} = block_struct(b).frags_used{end}(:, 1:block_struct(b).n_img_pres(end));
                end
            end
       end
	end
	stimon_getsecs = cat(1, block_struct(:).stimon_getsecs);

	pres_sketches = cellfun(@(x) ismember(x, sketch_images), image_list);
	pres_silhouettes = cellfun(@(x) ismember(x, silhouette_images), image_list);
	if silhouettes_only == -1
		pres_silhouettes = ~pres_silhouettes;
	end
	pres_cartoons = cellfun(@(x) ismember(x, cartoon_images), image_list);

    asynchronies = cat(1,block_struct(:).asynchronies);
    correct = cat(2,block_struct(:).correct)';
    response = cat(2, block_struct(:).response)';
    n_img_pres = cat(1,block_struct(:).n_img_pres);
    asynchronies = asynchronies * 100/17;
    asynchronies(asynchronies == 0 & n_img_pres == 1) = -10;
    category = exp_params.image_categories(cat(1,block_struct(:).presentations))';
    presentations = cat(1,block_struct(:).presentations);
    frags_used = cat(2, block_struct(:).frags_used)';
    rts = cat(2, block_struct(:).reaction_time)';
    soas = diff(cat(1, block_struct(:).stimon_getsecs), 1, 2);

    %exclude trials in which the SOA was incorrect, due to computer lag. Going to accept one frame of delay, but no more.
    %More clearly, we exclude a trial if more than one SOA is wrong, or if one SOA is wrong by more than one refresh.
    %That's what happens if the " | sum..." stuff is uncommented. Otherwise, we limit each SOA to being wrong by one refresh.
    bad_soas = any(repmat(asynchronies/1000 + .008, [1 size(soas, 2)]) < soas | repmat(asynchronies/1000 - .008, [1 size(soas, 2)]) > soas, 2) | ...
        sum(repmat(asynchronies/1000 + .003, [1 size(soas, 2)]) < soas | repmat(asynchronies/1000 - .003, [1 size(soas, 2)]) > soas, 2) > 2;
    if mean(bad_soas) > .25
        disp(['excluding subject ' exp_params.subject ' because of too many bad SOAs: ' num2str(sum(bad_soas))])
        excluded_subjects(j) = 1;
        continue
    end
    asynchronies(bad_soas) = [];
    correct(bad_soas) = [];
    response(bad_soas) = [];
    n_img_pres(bad_soas) = [];
    category(bad_soas) = [];
    presentations(bad_soas) = [];
    stimon_getsecs(bad_soas, :) = [];
    frags_used(bad_soas) = [];
    rts(bad_soas) = [];
    soas(bad_soas, :) = [];
    if eyefile==1
        eye_trials(bad_soas, :, :) = [];
    end

    
    if eyefile==1 && use_eyetracking==1 %get rid of trials marred by blinks or not looking;
    	fix_spot = (screen_coords(3:4)+1)/2;
    	eye_trial_important_samples = zeros(size(eye_trials(:,:,1)));
    	for t = 1:size(eye_trials, 1)
    		eye_trial_important_samples(t, pre_trial_time*500/1000+1) = 1;
    		for i = 2:sum(~isnan(stimon_getsecs(t, :)))
    			eye_trial_important_samples(t, pre_trial_time*500/1000+1 + round((stimon_getsecs(t, i) - stimon_getsecs(t, 1))*1000/500)) = 1;
    		end
    	end
        imp_samp_filt = [zeros(1, 5), ones(1, round(exp_params.n_image_frames * exp_params.refresh_dur * 500) + 10)];
    	eye_trial_important_samples = logical(conv2(eye_trial_important_samples, imp_samp_filt, 'same'));
    	bad_eye_trials = zeros(size(eye_trials, 1), 1);
    	for t = 1:length(bad_eye_trials)
    		tet = squeeze(eye_trials(t, :, :));
    		tetisx = tet(squeeze(eye_trial_important_samples(t, :)), 1);
    		tetisy = tet(squeeze(eye_trial_important_samples(t, :)), 2);
			if sum(isnan(tetisx))>0 || max(sqrt((tetisx - fix_spot(1)).^2 + (tetisy - fix_spot(2)).^2)) > fix_spot(1)/3
				bad_eye_trials(t) = 1;
			end
        end
     % if there were more than 15% of trials so marred, don't do this, as there was probably
    % a problem with the eye tracker.
        if mean(bad_eye_trials) > .15
        	bad_eye_trials = zeros(size(bad_eye_trials));
            lousy_eyetracking = 1;
        else
            lousy_eyetracking = 0;
		end
        bad_eye_trials = logical(bad_eye_trials);
        asynchronies(bad_eye_trials) = [];
        correct(bad_eye_trials) = [];
        response(bad_eye_trials) = [];
        n_img_pres(bad_eye_trials) = [];
        category(bad_eye_trials) = [];
        stimon_getsecs(bad_eye_trials, :) = [];
        rts(bad_eye_trials) = [];
        presentations(bad_eye_trials) = [];
        frags_used(bad_eye_trials) = [];
        soas(bad_eye_trials, :) = [];
        if eyefile==1
        	eye_trials(bad_eye_trials, :, :) = [];
        end
    else
        bad_eye_trials = logical(zeros(size(asynchronies)));
    end
    
    clear is_catch_trial
    %if there were catch trials, handle them.
    if isfield(block_struct(1), 'is_catch_trial')
        is_catch_trial = cat(1,block_struct(:).is_catch_trial);
        is_catch_trial(bad_soas) = [];
        is_catch_trial(bad_eye_trials) = [];
        %make sure performance on catch trials is decent
        if mean(correct(is_catch_trial)) < .8
            disp(['excluding subject ' exp_params.subject ' because catch-trial performance was low: ' num2str(mean(correct(is_catch_trial)))])
            excluded_subjects(j) = 1;
            continue
        end
        [cpbs, ccbs] = binofit(nansum(correct(is_catch_trial)), nansum(is_catch_trial));
        
        %remove catch trials from future consideration for this subject
        asynchronies(is_catch_trial) = [];
        correct(is_catch_trial) = [];
        response(is_catch_trial) = [];
        n_img_pres(is_catch_trial) = [];
        category(is_catch_trial) = [];
        presentations(is_catch_trial) = [];
        stimon_getsecs(is_catch_trial, :) = [];
        frags_used(is_catch_trial) = [];
        rts(is_catch_trial) = [];
        soas(is_catch_trial, :) = [];
        if eyefile==1
        	eye_trials(is_catch_trial, :, :) = [];
        end
    end
    
    %exclude subject if overall performance is abominable
    if mean(correct) < 1/3
        disp(['excluding subject ' exp_params.subject ' because overall performance was low: ' num2str(mean(correct))])
        excluded_subjects(j) = 1;
        continue
    end
    
	% Remove trials with asynchrony beyond the cutoff value
	if max_async > 0
		long_trials = asynchronies > max_async;
        asynchronies(long_trials) = [];
        correct(long_trials) = [];
        response(long_trials) = [];
        n_img_pres(long_trials) = [];
        category(long_trials) = [];
        stimon_getsecs(long_trials, :) = [];
        rts(long_trials) = [];
        presentations(long_trials) = [];
        frags_used(long_trials) = [];
        soas(long_trials, :) = [];
        if eyefile==1
        	eye_trials(long_trials, :, :) = [];
        	if use_eyetracking==1
        		bad_eye_trials(long_trials) = [];
			end
        end
	end
	
	
    %eliminate trials containing "obvious" fragments
    if use_frag_obviousness_filter
    	obvious_trials = zeros(size(presentations));
       load('/KLAB_BACKUP/people/jedsinger/async_psych_subjects/img_frag_master_obviousness.mat');
    	for t = 1:length(obvious_trials)
    		obvious_trials(t) = sum(img_frag_obviousness(strcmp(image_list(presentations(t)), img_names), reshape(frags_used{t}, 1, [])) > obv_thresh) > 0;
    	end
    	fraction_obvious(end+1) = sum(obvious_trials)/length(asynchronies);
    	obvious_trials = logical(obvious_trials);
        asynchronies(obvious_trials) = [];
        correct(obvious_trials) = [];
        response(obvious_trials) = [];
        n_img_pres(obvious_trials) = [];
        category(obvious_trials) = [];
        soas(obvious_trials) = [];
        stimon_getsecs(obvious_trials, :) = [];
        rts(obvious_trials) = [];
        presentations(obvious_trials) = [];
        frags_used(obvious_trials) = [];
        if eyefile==1
        	eye_trials(obvious_trials, :, :) = [];
        	if use_eyetracking==1
        		bad_eye_trials(obvious_trials) = [];
			end
        end
	end
	
    sketches = pres_sketches(presentations)';
    silhouettes = pres_silhouettes(presentations)';
    cartoons = pres_cartoons(presentations)';
	if strcmp(version,'original') || strcmp(version,'hardnomem') || strcmp(version,'mega')
		sketches = ones(size(sketches));
		silhouettes = ones(size(silhouettes));
		cartoons = ones(size(cartoons));
	end

    has_catch_trials(end+1) = isfield(block_struct(1), 'is_catch_trial');
    if has_catch_trials(end)
        catch_perf_by_subj(end+1) = cpbs;
        catch_ci_by_subj(1:2, end+1) = ccbs;
    end
    if eyefile==1 && use_eyetracking==1 && lousy_eyetracking==0
        used_eyetracking_by_subj(end+1) = 1;
        bad_eye_trials_by_subj(end+1) = nansum(bad_eye_trials);
    else
        used_eyetracking_by_subj(end+1) = 0;
        bad_eye_trials_by_subj(end+1) = 0;
    end
        
    sind = length(has_catch_trials);
    
    n_firsth = floor(length(correct)/2);
    n_secondh = length(correct(floor(length(correct)/2):end));
    c_firsth = sum(correct(1:floor(length(correct)/2)));
    c_secondh = sum(correct(floor(length(correct)/2):end));
    mc = mean(correct);
    halves_obs = [c_firsth, n_firsth-c_firsth, c_secondh, n_secondh-c_secondh];
    halves_exp = [n_firsth*[mc, 1-mc] n_secondh*[mc, 1-mc]];
    halves_chi2(sind) = chi2gof(1:4, 'frequency', halves_obs, 'expected', halves_exp, 'ctrs', 1:4, 'nparams', 2);
    halves_chi2(sind) = halves_chi2(sind) * ((-1)^(c_firsth > c_secondh));

        for nip = (mna-1):3
            counts_by_n_img_pres(:, nip, sind) = category_counts(asynchronies(n_img_pres==nip+1));
            [perf_by_n_img_pres(:, nip, sind), perf_ci_by_n_img_pres(:, nip, sind, 1:2)] = binofit(category_sums(correct(n_img_pres==nip+1), asynchronies(n_img_pres==nip+1)), counts_by_n_img_pres(:, nip, end)');
        end
        for nip = 1:(mna-2)
            counts_by_n_img_pres(:, nip, sind) = nan;
            perf_by_n_img_pres(:, nip, sind) = nan;
            perf_ci_by_n_img_pres(:, nip, sind, 1:2) = nan;
        end
        [atom_correct_by_subj(sind), atom_ci_by_subj(1:2, sind)] = binofit(nansum(correct(n_img_pres==1)), nansum(n_img_pres==1));
        atom_counts_by_subj(sind) = nansum(n_img_pres==1);
        good_trials_by_subj(sind) = length(correct);
        rt_median_by_subj(sind) = median(rts(correct))*1000;
        rt_sem_by_subj(sind) = std(rts(correct))*1000/sqrt(sum(correct));
	categories{sind} = category;
	responses{sind} = response;
	corrects{sind} = correct;
	subj_asyncs{sind} = asynchronies;
	subj_nip{sind} = n_img_pres;
end

final_subj_list = subj_list(~excluded_subjects);
asyncs = unique(asynchronies);
asyncs = asyncs(2:end);

save(['/KLAB_BACKUP/people/jedsinger/behavior_figures/async_psych_' version '_combined_data_' num2str([obv_thresh max_async min_combofit_atoms], '%1.2f_%1.2f_%1.2f') '.mat']);
end %end of the code that makes the above file

rgb2labfunc = @(x) colorspace('RGB->Lab',x);
if strcmp(version, 'mega')

    figure; this_colormap = distinguishable_colors(length(atom_correct_by_subj), 'w', rgb2labfunc); set(gcf, 'DefaultAxesColorOrder', this_colormap);
    norm_perf = (perf_by_n_img_pres*4-1)/3;
    for s = 1:size(norm_perf, 3)
        norm_perf(:, :, s) = (norm_perf(:, :, s) - min(min(norm_perf(:, :, s)))) / range(reshape(norm_perf(:, :, s), 1, []));
    end
    plot(asyncs, squeeze(norm_perf(:, 2, :)), 'g'); hold on
    plot(asyncs, mean(squeeze(norm_perf(:, 2, :))'), 'k', 'LineWidth', 3);
    plot(asyncs, squeeze(norm_perf(:, 3, :)), 'r'); hold on
    plot(asyncs, mean(squeeze(norm_perf(:, 3, :))'), 'k', 'LineWidth', 3);
    xlim([-10 300])
    title('Individual performance by asynchrony, four fragments per trial');
    print('-dpdf', '-r300', '/KLAB_BACKUP/people/jedsinger/behavior_figures/Indiv_diff_four_frags.pdf')
end


if silhouettes_only ~= 0
	counts_by_n_img_pres = silhouette_counts_by_n_img_pres;
	perf_by_n_img_pres = silhouette_perf_by_n_img_pres;
	perf_ci_by_n_img_pres = silhouette_perf_ci_by_n_img_pres;
	atom_correct_by_subj = silhouette_atom_correct_by_subj;
	atom_ci_by_subj = silhouette_atom_ci_by_subj;
	atom_counts_by_subj = silhouette_atom_counts_by_subj;
end




%% in-depth individual subject performance
n_subjs = length(atom_correct_by_subj);
n_asyncs = size(counts_by_n_img_pres, 1);
for s = 1:n_subjs
    for nip = (mna-1):3
        [~, conf_int(s, nip, :)] = binofit(sum(counts_by_n_img_pres(:, nip, s) .* perf_by_n_img_pres(:, nip, s)), sum(counts_by_n_img_pres(:, nip, s)), .05/n_asyncs);
    end
end

correct_by_n_img_pres = round(counts_by_n_img_pres .* perf_by_n_img_pres); %round just to coerce it to integers.
expected_by_n_img_pres = counts_by_n_img_pres .* repmat(sum(correct_by_n_img_pres) ./ sum(counts_by_n_img_pres), [n_asyncs 1 1]);

marker_symbols = 'o^s';
legend_words = {'2 atoms', '3 atoms', '4 atoms'};

for s = 1:n_subjs
    figure; hold on
    for nip = (mna-1):3
        chi2obs = reshape([squeeze(correct_by_n_img_pres(:, nip, s)), squeeze(counts_by_n_img_pres(:, nip, s) - correct_by_n_img_pres(:, nip, s))]', 1, []);
        chi2exp = reshape([squeeze(expected_by_n_img_pres(:, nip, s)), squeeze(counts_by_n_img_pres(:, nip, s) - expected_by_n_img_pres(:, nip, s))]', 1, []);
        %while not clearly built the same, this gives the same results as example 24.17, chapter 24.13, pp 555-556, "Biostatistical Analysis" 5th edition, by Jerrold H. Zar
        [~, chi2prob(s, nip)] = chi2gof(1:2*n_asyncs, 'frequency', chi2obs, 'expected', chi2exp, 'ctrs', 1:2*n_asyncs, 'nparams', n_asyncs);
        chi2prob(chi2prob == 0) = nan;
        data_handle = errorbarplot([], squeeze(perf_ci_by_n_img_pres(asyncs<300, nip, s, :)), asyncs(asyncs<300), squeeze(perf_by_n_img_pres((asyncs<300), nip, s)), [marker_symbols(nip) 'k'], 'MarkerFaceColor', (nip+1)*[.01 .01 .01], 'MarkerEdgeColor', (nip+1)*[.01 .01 .01], 'Color', (nip+1)*[.01 .01 .01]);
        legend(data_handle, legend_words{nip}); legend boxoff
    end
    if max(asyncs) > 300
        errorbarplot([], squeeze(perf_ci_by_n_img_pres(end, mna-1:3, s, :)), asyncs(end)-380, squeeze(perf_by_n_img_pres(end, mna-1:3, s)), 'o', 'MarkerFaceColor', (nip+1)*[.01 .01 .01], 'MarkerEdgeColor', (nip+1)*[.01 .01 .01], 'Color', (nip+1)*[.01 .01 .01]);
    end
    errorbarplot([], squeeze(atom_ci_by_subj(:, s)), 0, atom_correct_by_subj(s), '*k', 'MarkerFaceColor', [.01 .01 .01], 'MarkerEdgeColor', [.01 .01 .01], 'Color', [.01 .01 .01]);
    set(gca, 'XTick', [0:50:300], 'XTickLabel', [0:50:300]);
    bigexpected = sum(sum(correct_by_n_img_pres(:, mna-1:3, s))) / sum(sum(counts_by_n_img_pres(:, mna-1:3, s)));
    [~, bigchi2(s), ~] = chi2gof(1:2*(5-mna), 'frequency', reshape([nansum(correct_by_n_img_pres(:, mna-1:3, s)); nansum(counts_by_n_img_pres(:, mna-1:3, s) - correct_by_n_img_pres(:, mna-1:3, s))], 1, []), ...
        'expected', reshape([nansum(counts_by_n_img_pres(:, mna-1:3, s)) * bigexpected; nansum(counts_by_n_img_pres(:, mna-1:3, s)) * (1 - bigexpected)], 1, []), 'ctrs', 1:2*(5-mna), 'nparams', 5-mna);
    expected_perf_ordering(s) = all(diff(mean(perf_by_n_img_pres(:, mna-1:3, s))) > 0);
    if strcmp(version, 'original') || strcmp(version, 'hardnomem')
        xmax = 300;
    else
        xmax = 700;
    end
    if max_async > 0
		xmax = max_async + 10;
	end
    
    options = optimset('TypicalX', [50 -.15 120 .97 .5], 'Display', 'off'); 
    fitparams_combosig{s} = lsqcurvefit(@fit_combosig, [50 -.15 120 .97 .5], [min_combofit_atoms asyncs'], reshape(perf_by_n_img_pres(:, min_combofit_atoms-1:3, s), [], 1)', [1 -.5 0 .75 .25], [500 0 1000 1 .75], options);
    model_combosig = fit_combosig(fitparams_combosig{s}, [min_combofit_atoms asyncs']);
    AIC_combosig(s) = -2 * sum(log(binopdf(reshape(correct_by_n_img_pres(:, min_combofit_atoms-1:3, s), 1, []), reshape(counts_by_n_img_pres(:, min_combofit_atoms-1:3, s), 1, []), ...
        reshape(model_combosig, 1, [])))) + 2*5 + 2*5*6/((5-min_combofit_atoms)*n_asyncs - 5 - 1);

    options = optimset('TypicalX', [100 .2 .97 .5], 'Display', 'off'); 
    fitparams_comboexp{s} = lsqcurvefit(@fit_comboexp, [100 .2 .97 .5], [min_combofit_atoms asyncs'], reshape(perf_by_n_img_pres(:, min_combofit_atoms-1:3, s), [], 1)', [.00001 .00001 .00001 0], [1000 1 1 1], options);
    model_comboexp = fit_comboexp(fitparams_comboexp{s}, [mna asyncs']);
plot(0:300, reshape(fit_comboexp(fitparams_comboexp{s}, [min_combofit_atoms 0:300]), [], 5-min_combofit_atoms), '-.')
    AIC_comboexp(s) = -2 * sum(log(binopdf(reshape(correct_by_n_img_pres(:, mna-1:3, s), 1, []), reshape(counts_by_n_img_pres(:, mna-1:3, s), 1, []), ...
        reshape(model_comboexp, 1, [])))) + 2*4 + 2*4*5/((5-min_combofit_atoms)*n_asyncs - 4 - 1);


    for nip = (mna-1):3
        comboexp_rsquared(s, nip) = 1 - sum((perf_by_n_img_pres(:, nip, s) - model_comboexp(((1:length(asyncs)) + (nip-mna+1)*length(asyncs)))').^2)/var(perf_by_n_img_pres(:, nip, s), 1)/length(asyncs);
        comboexp_rmse(s, nip) = (sum((perf_by_n_img_pres(:, nip, s) - model_comboexp(((1:length(asyncs)) + (nip-mna+1)*length(asyncs)))').^2)/length(asyncs))^.5;
        %combosig_rsquared(s, nip) = 1 - sum((perf_by_n_img_pres(:, nip, s) - model_combosig(((1:length(asyncs)) + (nip-mna+1)*length(asyncs)))').^2)/var(perf_by_n_img_pres(:, nip, s), 1)/length(asyncs);
        colors = get(gca, 'ColorOrder');
        options = optimset('TypicalX', [20 .4 60 .3], 'Display', 'off');
        [fitparams_sig{s, nip}, sses_sig{s, nip}] = lsqcurvefit(@fitlogsig, [20 .4 60 .3], asyncs, perf_by_n_img_pres(:, nip, s), [.001 -1 0 0], [200 1 400 2], options);
        model_sig = fitlogsig(fitparams_sig{s, nip}, asyncs);
        options = optimset('TypicalX', [100 .2 .5], 'Display', 'off');
        [fitparams_exp{s, nip}, sses_exp{s, nip}] = lsqcurvefit(@fitexp, [100 .2 .5], asyncs, perf_by_n_img_pres(:, nip, s), [.00001 -1 atom_correct_by_subj(s)], [1000 1 1], options);
colorchars = 'rgb';
        model_exp = fitexp(fitparams_exp{s, nip}, asyncs);
        exp_rsquared(s, nip) = 1 - sses_exp{s, nip}/var(perf_by_n_img_pres(:, nip, s), 1)/length(model_exp);
        exp_rmse(s, nip) = (sses_exp{s, nip}/length(model_exp))^.5;
        AIC_sig(s, nip) = -2 * sum(log(binopdf(correct_by_n_img_pres(:, nip, s), counts_by_n_img_pres(:, nip, s), model_sig))) + 2*4 + 2*4*5/(n_asyncs-4-1);%
        AIC_exp(s, nip) = -2 * sum(log(binopdf(correct_by_n_img_pres(:, nip, s), counts_by_n_img_pres(:, nip, s), model_exp))) + 2*3 + 2*3*4/(n_asyncs-3-1);%
    end
    AIC_exp_total(s) = sum(AIC_exp(s, :)) - size(AIC_exp, 2)*(2*3*4/(n_asyncs-3-1)) + 2*6*7/((5-min_combofit_atoms)*n_asyncs - 6 - 1);
    if has_catch_trials(s)
       errorbarplot([], catch_ci_by_subj(:, sum(has_catch_trials(1:s)))', 0, catch_perf_by_subj(sum(has_catch_trials(1:s))), 'd', 'MarkerFaceColor', [.06 .06 .06], 'MarkerEdgeColor', [.06 .06 .06], 'Color', [.06 .06 .06]);
    end
    
	xlim([-10 310])
    ylim([.2 1])
	set(gca, 'YTick', .2:.2:1, 'YTickLabel', .2:.2:1);
    xlabel('SOA (ms)');
    ylabel('Fraction correct');
a = fitparams_combosig{s}(1);
c = fitparams_combosig{s}(3);
z = exp(c/a)/(1+exp(c/a)) + exp((c-eee)/a)/(1+exp((c-eee)/a));
combosig_x_value = c-a*log((.5*z)/(1-.5*z)); %z here only allows for r of .5
a = cat(1, fitparams_sig{s,:});
c = a(:, 3);
a = a(:, 1);
z = exp(c./a)./(1+exp(c./a)) + exp((c-eee)./a)./(1+exp((c-eee)./a));
sig_x_values = c-a.*log((.5*z)./(1-.5*z)); %z here only allows for r of .5
a = fitparams_comboexp{s}(1);
b = fitparams_comboexp{s}(2);
comboexp_x_value = -b + a*log(2) - a.*log(exp(-b./a) + exp((b+eee)./-a));
comboexp_x_value = fitparams_comboexp{s}(1);
weighted_x_value = comboexp_x_value;
    line([weighted_x_value weighted_x_value], ylim, 'LineStyle', ':', 'Color', [.07 .07 .07]);
    line(xlim, [.25 .25], 'LineStyle', ':', 'Color', [.08 .08 .08]);
    title({['Subj. ' num2str(final_subj_list(s)) ', chi2probs: ' num2str(chi2prob(s, 1), '%0.2f') ', ' num2str(chi2prob(s, 2), '%0.2f') ', ' num2str(chi2prob(s, 3), '%0.2f') '. N=' num2str(good_trials_by_subj(s)) ', bad em=' num2str(bad_eye_trials_by_subj(s))], ...
        ['group chi2prob: ' num2str(bigchi2(s), '%0.2f') '; rt median=' num2str(round(rt_median_by_subj(s))) ' +/- ' num2str(round(rt_sem_by_subj(s))) ' ms, stimuli approx. 9.3 deg.'], ...
        ['Obviousness <= ' num2str(obv_thresh) ', comboexp_tau = ' num2str(fitparams_comboexp{s}(1))], ...
        num2str(category_counts(responses{s}(responses{s} > 4 & responses{s} < 9))', 'Number of responses by button: %1.2f %1.2f %1.2f %1.2f')}); %, ...
end

atom_correct = nanmean(atom_correct_by_subj);


%can we do a population model?
%don't normalize performance...

options = optimset('TypicalX', [50 -.15 120 .97 .5], 'Display', 'off'); 
fitparams_pop_combosig = lsqcurvefit(@fit_combosig, [50 -.15 120 .97 .5], repmat([min_combofit_atoms asyncs'], [n_subjs 1]), reshape(perf_by_n_img_pres(:, min_combofit_atoms-1:3, :), n_asyncs * (5-min_combofit_atoms), [])', [1 -.5 0 .5 0], [500 0 1000 1 1], options);
model_pop_combosig = fit_combosig(fitparams_pop_combosig, [min_combofit_atoms asyncs']);
figure; plot(0:xmax, reshape(fit_combosig(fitparams_pop_combosig, [min_combofit_atoms 0:xmax]), [], (5-min_combofit_atoms)), '--')
hold on; plot(asyncs, nanmean(perf_by_n_img_pres, 3)); hold on;
sem_by_n_img_pres = squeeze(nansem(perf_by_n_img_pres, 0, 3));
plot(asyncs, nanmean(perf_by_n_img_pres, 3) + sem_by_n_img_pres, ':');
plot(asyncs, nanmean(perf_by_n_img_pres, 3) - sem_by_n_img_pres, ':');
plot(-10, atom_correct, 'o');
line([-10 -10], [atom_correct - nansem(atom_correct_by_subj) atom_correct + nansem(atom_correct_by_subj)]);
xlim([-30 720])
if strcmp(version, 'original') || strcmp(version, 'hardnomem')
    xlim([-30 320])
end
if max_async > 0
	xlim([-30 max_async + 30])
end
AIC_pop_combosig = -2 * sum(log(binopdf(reshape(correct_by_n_img_pres(:, min_combofit_atoms-1:3, :), 1, []), reshape(counts_by_n_img_pres(:, min_combofit_atoms-1:3, :), 1, []), ...
	repmat(reshape(model_pop_combosig, 1, []), [1 n_subjs])))) + 2*5 + 2*5*6/((5-min_combofit_atoms)*n_asyncs*n_subjs - 5 - 1);
legend('2 atoms', '3 atoms', '4 atoms');
title(version)

%can we do an exponential population model?
%don't normalize performance...
options = optimset('TypicalX', [100 .2 .95 .5], 'Display', 'off'); 
fitparams_pop_comboexp = lsqcurvefit(@fit_comboexp, [100 .2 .95 .5], repmat([min_combofit_atoms asyncs'], [n_subjs 1]), reshape(perf_by_n_img_pres(:, min_combofit_atoms-1:3, :), n_asyncs * (5-min_combofit_atoms), [])', [.00001 .00001 .00001 0], [1000 1 1 1], options);
model_pop_comboexp = fit_comboexp(fitparams_pop_comboexp, [mna asyncs']);
figure; plot(0:xmax, reshape(fit_comboexp(fitparams_pop_comboexp, [min_combofit_atoms 0:xmax]), [], (5-min_combofit_atoms)), '--')
hold on; plot(asyncs, nanmean(perf_by_n_img_pres, 3)); hold on;
sem_by_n_img_pres = squeeze(nansem(perf_by_n_img_pres, 0, 3));
plot(asyncs, nanmean(perf_by_n_img_pres, 3) + sem_by_n_img_pres, ':');
plot(asyncs, nanmean(perf_by_n_img_pres, 3) - sem_by_n_img_pres, ':');
plot(-10, atom_correct, 'o');
line([-10 -10], [atom_correct - nansem(atom_correct_by_subj) atom_correct + nansem(atom_correct_by_subj)]);
xlim([-30 720])
if strcmp(version, 'original') || strcmp(version, 'hardnomem')
    xlim([-30 320])
end
if max_async > 0
	xlim([-30 max_async + 30])
end
legend('2 atoms', '3 atoms', '4 atoms');
title(version)
%All together for the figure!
figure; hold on
plot(0:300, reshape(fit_comboexp(fitparams_pop_comboexp, [min_combofit_atoms 0:300]), [], (5-min_combofit_atoms)), '-.')
if strcmp(version, 'hard')
    xlim([-10 340])
plot(310:340, reshape(fit_comboexp(fitparams_pop_comboexp, [min_combofit_atoms 690:720]), [], (5-min_combofit_atoms)), '-.')
set(gca, 'XTick', [0:50:250 320], 'XTickLabel', [0:50:250 700]);
else
    xlim([-10 310])
set(gca, 'XTick', [0:50:300], 'XTickLabel', [0:50:300]);
end
if strcmp(version, 'mega')
    ylim([.3 .8])
else
    ylim([.25 .6])
end
sem_by_n_img_pres = squeeze(nansem(perf_by_n_img_pres, 0, 3));
marker_symbols = 'o^s';
for ac = 3:-1:mna-1
    mean_perf = nanmean(perf_by_n_img_pres(:, ac, :), 3);
    data_handle = errorbarplot([], sem_by_n_img_pres(asyncs < 300, ac), asyncs(asyncs < 300), mean_perf(asyncs < 300), marker_symbols(ac), 'MarkerFaceColor', (ac+1)*[.01 .01 .01], 'MarkerEdgeColor', (ac+1)*[.01 .01 .01], 'Color', (ac+1)*[.01 .01 .01]);
    if max(asyncs) > 300
        errorbarplot(max(asyncs) - 380, sem_by_n_img_pres(end, ac), max(asyncs) - 380, mean_perf(end), marker_symbols(ac), 'MarkerFaceColor', (ac+1)*[.01 .01 .01], 'MarkerEdgeColor', (ac+1)*[.01 .01 .01], 'Color', (ac+1)*[.01 .01 .01]);
    end
    pop_comboexp_rsquared(ac-mna+2) = 1 - sum((mean_perf - model_pop_comboexp((1:length(asyncs)) + (ac-mna+1)*length(asyncs))').^2)/var(mean_perf, 1)/length(asyncs);
    pop_comboexp_rmse(ac-mna+2) = (sum((mean_perf - model_pop_comboexp((1:length(asyncs)) + (ac-mna+1)*length(asyncs))').^2)/length(asyncs))^.5;
end
errorbarplot(0, nansem(atom_correct_by_subj), 0, atom_correct, '*', 'MarkerFaceColor', [.01 .01 .01], 'MarkerEdgeColor', [.01 .01 .01], 'Color', [.01 .01 .01]);
title(version)

xlabel('SOA (ms)')
ylabel('Mean fraction correct')
a = fitparams_pop_combosig(1);
c = fitparams_pop_combosig(3);
z = exp(c/a)/(1+exp(c/a)) + exp((c-eee)/a)/(1+exp((c-eee)/a));
combosig_x_value = c-a*log((.5*z)/(1-.5*z)); %z here only allows for r of .5

%the x-value at which the uncertainty reduction is 1/r of the reduction at x=0 is
%(log(r) + ab)/a - b, when a and b are fitparams_pop_comboexp(1:2)
a = fitparams_pop_comboexp(1);
b = fitparams_pop_comboexp(2);
comboexp_x_value = -b + a*log(2) - a*log(exp(-b/a) + exp((b+eee)/-a));
comboexp_x_value = a;
disp(num2str([fitparams_pop_comboexp], 'Population comboexp fit tau: %1.2f  Y-scale: %1.2f  asymptote: %1.2f  base perf: %1.2f'))

combo_pop_xval = comboexp_x_value;

%let's put in lines for probability summation
p = 1-(mean(atom_correct_by_subj)*4-1)/3;
if min_combofit_atoms == 2
	line(xlim, [1-p^2 + p^2/4 1-p^2 + p^2/4], 'LineStyle', ':', 'Color', [.16 .16 .16]);
end
line(xlim, [1-p^3 + p^3/4 1-p^3 + p^3/4], 'LineStyle', ':', 'Color', [.17 .17 .17]);
line(xlim, [1-p^4 + p^4/4 1-p^4 + p^4/4], 'LineStyle', ':', 'Color', [.22 .22 .22]);

line([combo_pop_xval combo_pop_xval], ylim, 'LineStyle', ':', 'Color', [.07 .07 .07]);
print('-dpdf', '-r300', ['/KLAB_BACKUP/people/jedsinger/behavior_figures/combofigure_async_psych_' version '_' num2str(obv_thresh) '.pdf']);

disp(num2str(uniform_perf_chi2gof(category_sums(cat(1, corrects{:}), cat(1, categories{:})), category_counts(cat(1, categories{:}))), 'Chi2 p-value for equal performance by all categories: %d'))
disp(num2str(category_means(cat(1, corrects{:}), cat(1, categories{:})), ['Performance by category: Animals: %1.2f  People: %1.2f  Plants: %1.2f  Vehicles: %1.2f']));
disp('Same as above, but per subject:')
for s=1:n_subjs
	disp(num2str([s uniform_perf_chi2gof(category_sums(corrects{s}, categories{s}), category_counts(categories{s}))], 'Subj. %d Chi2 p-value for equal performance by all categories: %1.3f'))
	disp(num2str(category_means(corrects{s}, categories{s}), ['Perf. by category: Animals: %1.2f  People: %1.2f  Plants: %1.2f  Vehicles: %1.2f']));
end


fitmat_comboexp = cell2mat(fitparams_comboexp');
a = fitmat_comboexp(:,1);
b = fitmat_comboexp(:,2);
comboexp_x_values = -b + a*log(2) - a.*log(exp(-b./a) + exp((b+eee)./-a));
comboexp_x_values = a;
disp(['Comboexp tau uncertainty reduction asyncs (median ' num2str(median(comboexp_x_values), '%1.2f ') '; mean ' num2str(mean(comboexp_x_values), '%1.2f ') '; sem ' num2str(nansem(comboexp_x_values), '%1.2f ') ') ms:']);
disp(num2str(comboexp_x_values', '%1.2f '));
fitmat_exp = nan(n_subjs, 9);
fitmat_exp(:, (mna-2)*3+1:end) = cell2mat(fitparams_exp);
fitmat_exp_decreases = fitmat_exp(:, 2:3:8);
uncertainty_reduction_factors = (perf_by_n_img_pres(1:end-1, :, :) - repmat(perf_by_n_img_pres(end, :, :), [n_asyncs - 1, 1, 1])) ./ (1 - repmat(perf_by_n_img_pres(end, :, :), [n_asyncs - 1, 1, 1]));

disp(['Subjects with significant differences by atom count: ' num2str(sum(bigchi2 < .05)) '/' num2str(n_subjs)])
disp(['Number of those subjects in which performance tracks atom count: ' num2str(sum(expected_perf_ordering(bigchi2 < .05))) '/' num2str(sum(bigchi2 < .05))])
disp(['Number of TOTAL subjects in which performance tracks atom count: ' num2str(sum(expected_perf_ordering)) '/' num2str(n_subjs)])

disp(['Subjects with significant performance differences between asynchronies at 2, 3, and 4 atoms: ' num2str([sum(chi2prob < .05, 1) n_subjs], '%d, %d, %d / %d')])


disp(['Number of significantly-asynchrony-affected subjects (at 2, 3, 4 atoms) in which best-fit exponential PDF decreases with asynchrony: ' num2str([sum(fitmat_exp_decreases .* (chi2prob < .05) > 0, 1) sum(chi2prob < .05, 1)], '%d, %d, %d / %d, %d, %d')])
disp(['Probability of seeing results this extreme by chance (two-tailed sign test): ' num2str([signtest(fitmat_exp_decreases(chi2prob(:,1) < .05, 1)) signtest(fitmat_exp_decreases(chi2prob(:,2) < .05, 2)) signtest(fitmat_exp_decreases(chi2prob(:,3) < .05, 3))], '%f, %f, %f')])
disp(['Number of TOTAL subjects (at 2, 3, 4 atoms) in which best-fit exponential PDF decreases with asynchrony: ' num2str([sum(fitmat_exp_decreases > 0, 1) n_subjs], '%d, %d, %d / %d')])
disp(['Probability of seeing results this extreme by chance (two-tailed sign test): ' num2str([signtest(fitmat_exp_decreases(:,1)) signtest(fitmat_exp_decreases(:,2)) signtest(fitmat_exp_decreases(:,3))], '%f, %f, %f')])

a = fitmat_exp(:, 1:3:7);
exp_x_values = 1000*(a .* log(2) - a .* log(1+exp(-eee/1000./a)));
exp_x_values = a;
exp_x_values(fitmat_exp_decreases <= 0) = nan;
disp(['Exponential PDF taus (for decreasing conditions only, medians ' num2str(nanmedian(exp_x_values), '%1.2f, %1.2f, %1.2f') '; means ' num2str(nanmean(exp_x_values), '%1.2f, %1.2f, %1.2f') '; sems ' num2str(nansem(exp_x_values), '%1.2f, %1.2f, %1.2f') ') ms:']);
disp(num2str(exp_x_values, '%1.2f, %1.2f, %1.2f'));

if obv_thresh < 1
	disp(['Obviousness filter of ' num2str(obv_thresh) ' eliminated on average ' num2str(mean(fraction_obvious), '%1.3f') ' +/- ' num2str(std(fraction_obvious)/sqrt(n_subjs), '%1.3f') ' of the trials.']);
end

disp([num2str(sum(halves_chi2>0)) ' of ' num2str(n_subjs) ' subjects showed a significant improvement between the first and second halves of the experiment (Chi-squared, p < .05). ' num2str(sum(halves_chi2<0)) ' got worse, significantly.'])
disp([num2str(sum(used_eyetracking_by_subj)) ' of ' num2str(n_subjs) ' subjects had eyetracking.'])
overall_perf_by_subj = squeeze(nansum(nansum(correct_by_n_img_pres, 2)) ./ nansum(nansum(counts_by_n_img_pres, 2)));
disp(['Perf. range: ' num2str([min(overall_perf_by_subj) max(overall_perf_by_subj)], '%0.2f-%0.2f') ', mean ' num2str(mean(overall_perf_by_subj), '%0.2f') ', SEM ' num2str(nansem(overall_perf_by_subj), '%0.2f')])
disp(['Catch perf: ' num2str(mean(catch_perf_by_subj)) ' +/- ' num2str(nansem(catch_perf_by_subj))])
disp(['Single-atom perf: ' num2str(mean(atom_correct_by_subj)) ' +/- ' num2str(nansem(atom_correct_by_subj))]);
exp_rsquared(:, 1:mna-2) = [];
exp_rmse(:, 1:mna-2) = [];
comboexp_rsquared(:, 1:mna-2) = [];
comboexp_rmse(:, 1:mna-2) = [];
disp(['Raw exponential fit median RMSE values for each number of atoms: ' num2str(median(exp_rmse), '%0.3f ') ' +/- ' num2str(nansem(exp_rmse), '%0.3f ')]);
disp(num2str(exp_rmse, '%1.3f '));
disp(['Uncertainty reduction model exponential fit median RMSE values for each number of atoms: ' num2str(median(comboexp_rmse), '%0.3f ') ' +/- ' num2str(nansem(comboexp_rmse), '%0.3f ')]);
disp(num2str(comboexp_rmse, '%1.3f '));
%Are the RMSEs from the two kinds of fits different? Wilcoxon rank sum test!
for nip = 1:(5-mna)
	ranksum_p(nip) = ranksum(exp_rmse(:, nip), comboexp_rmse(:, nip));
end
disp(['Wilcoxon rank sum test: do RMSEs have different medians between the two fits, for each number of atoms? ' num2str(ranksum_p, '%d ')])
disp(['Uncertainty reduction population model exponential fit RMSE values for each number of atoms: ' num2str(pop_comboexp_rmse, '%0.3f ')]);

%perf_by_n_img_pres(async, atomcount, subj)
unique_asyncs = unique(asynchronies);
for a = 2:n_asyncs
	stp = signtest(reshape(perf_by_n_img_pres(1, :, :), [], 1), reshape(perf_by_n_img_pres(a, :, :), [], 1));
	st_diff_mean = nanmean(reshape(perf_by_n_img_pres(1, :, :), [], 1) - reshape(perf_by_n_img_pres(a, :, :), [], 1));
    st_diff_sem = nansem(reshape(perf_by_n_img_pres(1, :, :), [], 1) - reshape(perf_by_n_img_pres(a, :, :), [], 1));
	disp(['Sign test p value ' num2str(stp, '%1.4f') ' for perf decrease of ' num2str(st_diff_mean*100, '%1.1f') ' +/- ' num2str(st_diff_sem*100, '%1.1f')  ' at SOA ' num2str(unique_asyncs(a+1), '%1.1f')])
end

disp('Ranksum test pvalues to see if there is a performance difference between simultaneous and near-simultaneous:')
for i = 1:size(perf_by_n_img_pres, 2)
	disp(num2str([i+1 ranksum(squeeze(perf_by_n_img_pres(1, i, :)), squeeze(perf_by_n_img_pres(2, i, :)))], 'Number of atoms: %d  P value: %1.4f'))
end

stp = signtest(reshape(perf_by_n_img_pres(end, :, :), [], 1), reshape(perf_by_n_img_pres(end-1, :, :), [], 1));
st_diff_mean = nanmean(reshape(perf_by_n_img_pres(end-1, :, :), [], 1) - reshape(perf_by_n_img_pres(end, :, :), [], 1));
st_diff_sem = nansem(reshape(perf_by_n_img_pres(end-1, :, :), [], 1) - reshape(perf_by_n_img_pres(end, :, :), [], 1));
disp(['Sign test p value ' num2str(stp, '%1.4f') ' for perf decrease of ' num2str(st_diff_mean*100, '%1.1f') ' +/- ' num2str(st_diff_sem*100, '%1.1f')  ' between longest two SOAs.'])

p = 1-(mean(atom_correct_by_subj)*4-1)/3;
disp(num2str([1-p^3 + p^3/4, 1-p^4 + p^4/4], 'Probability summation predictions based on mean atom performance for 3: %1.3f and 4: %1.3f atoms.'))
p = 1-(atom_correct_by_subj*4-1)/3;
disp('Probability summation predictions for individual subjects')
disp(num2str([1-p.^3 + p.^3/4; 1-p.^4 + p.^4/4]', '%1.3f '))
disp(num2str([mean(1-p.^3 + p.^3/4) nansem(1-p.^3 + p.^3/4) mean(1-p.^4 + p.^4/4) nansem(1-p.^4 + p.^4/4)], 'Means of the above for 3: %1.3f +/- %1.3f and 4: %1.3f +/- %1.3f atoms'))
disp(num2str([mean(perf_by_n_img_pres(end, 2, :)) nansem(perf_by_n_img_pres(end, 2, :)) mean(perf_by_n_img_pres(end, 3, :)) nansem(perf_by_n_img_pres(end, 3, :))], 'Mean long-async performance for 3: %1.3f +/- %1.3f and 4: %1.3f +/- %1.3f atoms'))

bob = cat(1, fitparams_comboexp{:});
disp(num2str([mean(bob(:, 4)) nansem(bob(:, 4)) mean(bob(:, 3)) nansem(bob(:, 3)) mean(bob(:, 2)) nansem(bob(:, 2))], 'Mean estimates for u: %f +/- %f, B'': %f +/- %f, and R'': %f +/- %f'))


%Make bar graph of performance at zero SOA
figure
bar([mean(atom_correct_by_subj) squeeze(mean(perf_by_n_img_pres(1, 2:3, :), 3)), mean(catch_perf_by_subj)]);
hold on
errorbar(1:4, [mean(atom_correct_by_subj) squeeze(mean(perf_by_n_img_pres(1, 2:3, :), 3)), mean(catch_perf_by_subj)], [nansem(atom_correct_by_subj) squeeze(nansem(perf_by_n_img_pres(1, 2:3, :), [], 3)), nansem(catch_perf_by_subj)], '.');
xlabel('Number of fragments')
set(gca, 'xticklabel', {'1', '3', '4', '5 (Catch)'})
ylabel('Mean performance (proportion correct)')
print('-dpdf', '-r300', ['/KLAB_BACKUP/people/jedsinger/behavior_figures/zero_SOA_' version '_' num2str(obv_thresh) '.pdf']);
close

save(['/KLAB_BACKUP/people/jedsinger/async_psych_subjects/alldata_' version '_' num2str(obv_thresh) '.mat'])
diary('off')
end
