subjects = dir('/KLAB_BACKUP/people/jedsinger/async_psych_clean_data/');
subjects = cat(1, subjects(3:end).name);

img_frag_obviousness = zeros(1200, 16);
img_frag_fractional_counts = zeros(1200, 16);
load('/KLAB_BACKUP/people/jedsinger/async_psych_clean_data/clean_async_p012', 'image_list')
img_names = image_list;
for s = 1:size(subjects, 1)
    clear('presentations', 'frags_used', 'correct', 'image_list', 'n_img_pres', 'asynchronies');
	load(['/KLAB_BACKUP/people/jedsinger/async_psych_clean_data/' subjects(s, :)], 'presentations', 'frags_used', 'correct', 'image_list', 'n_img_pres', 'asynchronies')
	presentations = arrayfun(@(x) find(strcmp(x, img_names)), image_list(presentations));
	s_perf = mean(correct);
    uniq_asyncs = unique(asynchronies);
    perf_by_cond = category_means(correct, 1000*n_img_pres + asynchronies);
	for t = 1:length(presentations)
        if n_img_pres(t) >= 2
            cond_perf = perf_by_n_img_pres(find(asynchronies(t)==uniq_asyncs)-1, n_img_pres(t)-1, end);
        else
            cond_perf = atom_correct_by_subj(end);
        end
		img_frag_obviousness(presentations(t), reshape(frags_used{t}, 1, [])) = img_frag_obviousness(presentations(t), reshape(frags_used{t}, 1, [])) + ...
            correct(t) * ones(1, length(reshape(frags_used{t}, 1, []))) / length(reshape(frags_used{t}, 1, [])) / cond_perf * s_perf;
		img_frag_fractional_counts(presentations(t), reshape(frags_used{t}, 1, [])) = img_frag_fractional_counts(presentations(t), reshape(frags_used{t}, 1, [])) + ...
            ones(1, length(reshape(frags_used{t}, 1, []))) / length(reshape(frags_used{t}, 1, [])) / cond_perf * s_perf;
	end
end
img_frag_obviousness(img_frag_fractional_counts>0) = img_frag_obviousness(img_frag_fractional_counts>0) ./ img_frag_fractional_counts(img_frag_fractional_counts>0);

save('/KLAB_BACKUP/people/jedsinger/async_psych_subjects/img_frag_master_obviousness.mat', 'img_frag_obviousness', 'img_names');

