%takes as input an mxn matrix of data; each of m data is an n-dimensional vector. Also takes a
%list of m categories. Returns an nxc matrix, where c is the number of distinct categories and
%the cth column contains the mean of all input data of category c.
function [cat_means unique_cats] = category_means(data, categories)

unique_cats = unique(categories); %unique also sorts in ascending order
cat_means = zeros(size(data,2), length(unique_cats));
for c = 1:length(unique_cats)
	cat_means(:, c) = squeeze(nanmean(data(categories == unique_cats(c), :), 1));
end