%takes as input an mxn matrix of data; each of m data is an n-dimensional vector. Also takes a
%list of m categories. Returns an nxc matrix, where c is the number of distinct categories and
%the cth column contains the sum of all input data of category c.
function [cat_sums unique_cats] = category_sums(data, categories)

unique_cats = unique(categories); %unique also sorts in ascending order
cat_sums = zeros(size(data,2), length(unique_cats));
for c = 1:length(unique_cats)
	cat_sums(:, c) = squeeze(nansum(data(categories == unique_cats(c), :), 1));
end