function yvals = fit_comboexp(params, xvals)
%fits a model like in "more async_psych" in my notebook; xvals(1) or xvals(1, 1) is the minimum number of atoms to consider; other things in the first column are ignored
min_n_atoms = xvals(1);
xvals(:, 1) = [];
if sum(size(xvals)==1)
	n_asyncs = length(xvals);
	onedim=1;
else
	n_asyncs = size(xvals, 2);
	onedim=0;
end

baseline_perf = params(4);

model_vals = my_fitexp(params(1:3), [xvals 2*xvals 3*xvals]);
%(1-baseline_perf)*4/3 is the presumed uncertain fraction as a function of observed atom
%performance; then we multiply it by our exponential uncertainty reduction functions, to
%get the uncertainty for the experimental conditions, then convert that back to
%expected performance by multiplying 1-unc. by 3, adding 1, and then dividing by 4.
switch min_n_atoms
	case 2
		if onedim
			yvals = [((1 - (1-baseline_perf) * 4/3 * [model_vals(1:n_asyncs) (model_vals(1:n_asyncs).^2).*model_vals(n_asyncs + (1:n_asyncs)) (model_vals(1:n_asyncs).^3).*(model_vals(n_asyncs + (1:n_asyncs)).^2).*(model_vals(2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		else
			yvals = [((1 - (1-baseline_perf) * 4/3 * [model_vals(:, 1:n_asyncs) (model_vals(:, 1:n_asyncs).^2).*model_vals(:, n_asyncs + (1:n_asyncs)) (model_vals(:, 1:n_asyncs).^3).*(model_vals(:, n_asyncs + (1:n_asyncs)).^2).*(model_vals(:, 2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		end
	case 3
		if onedim
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(1:n_asyncs).^2).*model_vals(n_asyncs + (1:n_asyncs)) (model_vals(1:n_asyncs).^3).*(model_vals(n_asyncs + (1:n_asyncs)).^2).*(model_vals(2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		else
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(:, 1:n_asyncs).^2).*model_vals(:, n_asyncs + (1:n_asyncs)) (model_vals(:, 1:n_asyncs).^3).*(model_vals(:, n_asyncs + (1:n_asyncs)).^2).*(model_vals(:, 2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		end
	case 4
		if onedim
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(1:n_asyncs).^3).*(model_vals(n_asyncs + (1:n_asyncs)).^2).*(model_vals(2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		else
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(:, 1:n_asyncs).^3).*(model_vals(:, n_asyncs + (1:n_asyncs)).^2).*(model_vals(:, 2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		end
end
end


function yvals = my_fitexp(param_yscale_asy, xvals) %my_fitexp(xstretch_xshift, xvals)
    yvals = param_yscale_asy(3) - param_yscale_asy(2)*2.^(-xvals/param_yscale_asy(1));
%	yvals = 1 - 1./exp(1/xstretch_xshift(1) * (xvals + xstretch_xshift(2)));
end