function yvals = fit_comboexp_sdt(params, xvals)
%fits a model like in "more async_psych" in my notebook; xvals(1) or xvals(1, 1) is the minimum number of atoms to consider. Other things in the first column are ignored
min_n_atoms = xvals(1);
xvals(:, 1) = [];
if sum(size(xvals)==1)
	n_asyncs = length(xvals);
	onedim=1;
else
	n_asyncs = size(xvals, 2);
	onedim=0;
end

efficiency_decay = params(3);
atom_perf = params(4);

model_vals = my_fitexp(params(1:2), [xvals 2*xvals 3*xvals]);
switch min_n_atoms
	case 2
		if onedim
			yvals = ...
			[repmat(sum(atom_perf * efficiency_decay.^[0:1]), [1 n_asyncs]) ...
				repmat(sum(atom_perf * efficiency_decay.^[0:2]), [1 n_asyncs]) ...
				repmat(sum(atom_perf * efficiency_decay.^[0:3]), [1 n_asyncs])] + ...
			[model_vals(1:n_asyncs) ...
				2 * model_vals(1:n_asyncs) + model_vals(n_asyncs + (1:n_asyncs)) ...
				3 * model_vals(1:n_asyncs) + 2 * model_vals(n_asyncs + (1:n_asyncs)) + model_vals(2*n_asyncs + (1:n_asyncs))];
		else
			yvals = ...
			[repmat(sum(atom_perf * efficiency_decay.^[0:1]), [size(xvals,1) n_asyncs]) ...
				repmat(sum(atom_perf * efficiency_decay.^[0:2]), [size(xvals,1) n_asyncs]) ...
				repmat(sum(atom_perf * efficiency_decay.^[0:3]), [size(xvals,1) n_asyncs])] + ...
			[model_vals(:, 1:n_asyncs) ...
				2 * model_vals(:, 1:n_asyncs) + model_vals(:, n_asyncs + (1:n_asyncs)) ...
				3 * model_vals(:, 1:n_asyncs) + 2 * model_vals(:, n_asyncs + (1:n_asyncs)) + model_vals(:, 2*n_asyncs + (1:n_asyncs))];
		end
	case 3
		if onedim
			yvals = ...
			[repmat(sum(atom_perf * efficiency_decay.^[0:2]), [1 n_asyncs]) ...
				repmat(sum(atom_perf * efficiency_decay.^[0:3]), [1 n_asyncs])] + ...
			[2 * model_vals(1:n_asyncs) + model_vals(n_asyncs + (1:n_asyncs)) ...
				3 * model_vals(1:n_asyncs) + 2 * model_vals(n_asyncs + (1:n_asyncs)) + model_vals(2*n_asyncs + (1:n_asyncs))];
		else
			yvals = ...
			[repmat(sum(atom_perf * efficiency_decay.^[0:2]), [size(xvals,1) n_asyncs]) ...
				repmat(sum(atom_perf * efficiency_decay.^[0:3]), [size(xvals,1) n_asyncs])] + ...
			[2 * model_vals(:, 1:n_asyncs) + model_vals(:, n_asyncs + (1:n_asyncs)) ...
				3 * model_vals(:, 1:n_asyncs) + 2 * model_vals(:, n_asyncs + (1:n_asyncs)) + model_vals(:, 2*n_asyncs + (1:n_asyncs))];
		end
%	case 4
end
end


function yvals = my_fitexp(param_yscale, xvals)
    yvals = param_yscale(2)*2.^(-xvals/param_yscale(1));
end