function yvals = fit_combosig(params, xvals)
%fits a model like in "more async_psych" in my notebook; xvals(1) or xvals(1, 1) is the minimum number of atoms to consider; other things in the first column are ignored
min_n_atoms = xvals(1);
xvals(:, 1) = [];
if sum(size(xvals)==1)
	n_asyncs = length(xvals);
	onedim=1;
else
	n_asyncs = size(xvals, 2);
	onedim=0;
end

baseline_perf = params(5);

model_vals = fitlogsig(params(1:4), [xvals 2*xvals 3*xvals]);
%(1-baseline_perf)*4/3 is the presumed uncertain fraction as a function of observed atom
%performance; then we multiply it by our sigmoid uncertainty reduction functions, to
%get the uncertainty for the experimental conditions, then convert that back to
%expected performance by multiplying 1-unc. by 3, adding 1, and then dividing by 4.
switch min_n_atoms
	case 2
		if onedim
			yvals = [((1 - (1-baseline_perf) * 4/3 * [model_vals(1:n_asyncs) (model_vals(1:n_asyncs).^2).*model_vals(n_asyncs + (1:n_asyncs)) (model_vals(1:n_asyncs).^3).*(model_vals(n_asyncs + (1:n_asyncs)).^2).*(model_vals(2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		else
			yvals = [((1 - (1-baseline_perf) * 4/3 * [model_vals(:, 1:n_asyncs) (model_vals(:, 1:n_asyncs).^2).*model_vals(:, n_asyncs + (1:n_asyncs)) (model_vals(:, 1:n_asyncs).^3).*(model_vals(:, n_asyncs + (1:n_asyncs)).^2).*(model_vals(:, 2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		end
	case 3
		if onedim
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(1:n_asyncs).^2).*model_vals(n_asyncs + (1:n_asyncs)) (model_vals(1:n_asyncs).^3).*(model_vals(n_asyncs + (1:n_asyncs)).^2).*(model_vals(2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		else
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(:, 1:n_asyncs).^2).*model_vals(:, n_asyncs + (1:n_asyncs)) (model_vals(:, 1:n_asyncs).^3).*(model_vals(:, n_asyncs + (1:n_asyncs)).^2).*(model_vals(:, 2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		end
	case 4
		if onedim
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(1:n_asyncs).^3).*(model_vals(n_asyncs + (1:n_asyncs)).^2).*(model_vals(2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		else
			yvals = [((1 - (1-baseline_perf) * 4/3 * [(model_vals(:, 1:n_asyncs).^3).*(model_vals(:, n_asyncs + (1:n_asyncs)).^2).*(model_vals(:, 2*n_asyncs + (1:n_asyncs)))]) * 3 + 1)/4];
		end
end

%Using this:
%options = optimset('TypicalX', [100 -.24 120 .95 .5]); 
%fitparams = lsqcurvefit(@fit_combosig, [100 -.24 120 .95 .5], asyncs, reshape(mean(perf_by_n_img_pres, 3), [], 1)', [1 -1 0 0 0], [1000 0 1000 1 1], options);
%bob = fit_combo_model(fitparams, asyncs);
%figure; plot(asyncs, reshape(bob, [], 3)); hold on; plot(-10, fitparams(5), 'o')