load /KLAB_BACKUP/people/jedsinger/behavior_figures/async_psych_mega_combined_data_0.80_0.00_3.00.mat
theory_floc = '/KLAB_BACKUP/people/jedsinger/mfiles/jags_files/';
jed_floc = '~/Desktop/jags_files/';
for s = 1:length(categories)
	codes = (categories{s}-1)*4 + responses{s}-4;
	unique_asyncs = unique(subj_asyncs{s});
	n_asyncs = length(unique_asyncs);
	unique_nip = unique(subj_nip{s});
	n_nip = length(unique_nip);
	for n = 1:n_nip
		for a = min(unique_nip(n), 2):min(n_asyncs, 1000000*(n-1)+1)
			fname = ['mega_s' num2str(s) '_n' num2str(unique_nip(n)) '_a' num2str(unique_asyncs(a)) '.txt'];
			script_fid = fopen(fullfile(theory_floc, ['jags_scripts/jags_script_' fname]), 'w');
			fid = fopen(fullfile(theory_floc, fname), 'w');
			[ccounts, cats] = category_counts(codes(subj_asyncs{s}==unique_asyncs(a) & subj_nip{s}==unique_nip(n)));
			subj_ccounts = zeros(16,1);
			subj_ccounts(cats) = ccounts;
			subj_ccounts_cum = cumsum(subj_ccounts);
			fprintf(fid, '#mega, subject %d, num. atoms %d, async %f\n', [s, unique_nip(n), unique_asyncs(a)]);
			fprintf(fid, '''N''<-%d\n''rculm''<-c(%d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d)\n', [sum(subj_ccounts), subj_ccounts_cum']);
			fprintf(fid, '''stim1s''<-c(1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0)\n');
			fprintf(fid, '''stim2s''<-c(0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0)\n');
			fprintf(fid, '''stim3s''<-c(0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0)\n');
			fprintf(fid, '''resp1s''<-c(1,2,2,2,1,2,2,2,1,2,2,2,1,2,2,2)\n');
			fprintf(fid, '''resp2s''<-c(2,1,2,2,2,1,2,2,2,1,2,2,2,1,2,2)\n');
			fprintf(fid, '''resp3s''<-c(2,2,1,2,2,2,1,2,2,2,1,2,2,2,1,2)');
			fclose(fid);
			
			fprintf(script_fid, ['model in "' jed_floc '4afc.txt"\n']);
			fprintf(script_fid, ['data in "' jed_floc fname '"\n']);
			fprintf(script_fid, 'compile\n');
			fprintf(script_fid, ['parameters in "' jed_floc '4afc_inits.txt"\n']);
			fprintf(script_fid, 'initialize\n');
			fprintf(script_fid, 'update 10000\n');
			fprintf(script_fid, 'monitor d\n');
			fprintf(script_fid, 'update 20000\n');
			fprintf(script_fid, ['coda d, stem("log_' fname '")\n']);
			fclose(script_fid);
		end
	end
end
