%performs a chi2gof evaluating whether the category-specific correct values in cat_counts_correct, given cat_counts_total trials, could plausibly happen if performance was equal between categories.
function p = uniform_perf_chi2gof(cat_counts_correct, cat_counts_total)

if size(cat_counts_correct, 1) < size(cat_counts_correct, 2)
	cat_counts_correct = cat_counts_correct';
end

if size(cat_counts_total, 1) < size(cat_counts_total, 2)
	cat_counts_total = cat_counts_total';
end

bins = 1:2*length(cat_counts_correct);
nparams = length(cat_counts_correct);
mean_perf = sum(cat_counts_correct)/sum(cat_counts_total);
expcounts = [cat_counts_total*mean_perf; cat_counts_total*(1-mean_perf)];
[~, p, ~] = chi2gof(bins, 'ctrs', bins, 'frequency', [cat_counts_correct; cat_counts_total - cat_counts_correct], 'expected', expcounts, 'nparams', nparams);
